import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u - 1, v - 1))  # Adjust to 0-based indexing

    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p - 1, h))  # Adjust to 0-based indexing

    adj = collections.defaultdict(list)
    for u, v in edges:
        adj[u].append(v)
        adj[v].append(u)

    def bfs(start_node):
        distances = [-1] * n
        distances[start_node] = 0
        queue = collections.deque([start_node])
        while queue:
            u = queue.popleft()
            for v in adj[u]:
                if distances[v] == -1:
                    distances[v] = distances[u] + 1
                    queue.append(v)
        return distances

    protected_warehouses = set()
    for guard_node, guard_range in guards:
        distances = bfs(guard_node)
        for i in range(n):
            if distances[i] != -1 and distances[i] <= guard_range:
                protected_warehouses.add(i + 1)

    protected_warehouses = sorted(list(protected_warehouses))
    print(len(protected_warehouses))
    if protected_warehouses:
        print(*protected_warehouses)


solve()

