
import random

def approximate_solve(n, m, k, edges, guards):
    # Хеш-таблица для быстрого поиска защищенных складов
    protected_warehouses = set()

    # Итеративный локальный поиск
    for _ in range(100): # Количество итераций - гиперпараметр, настраиваемый
        # Выбираем случайный охранник
        guard_index = random.randint(0, len(guards) - 1)
        guard_node, guard_range = guards[guard_index]

        # Проверяем окрестность охранника (с ограничением по глубине поиска)
        queue = [(guard_node, 0)]  # (узел, расстояние)
        while queue:
            current_node, distance = queue.pop(0)
            if distance <= guard_range:
                protected_warehouses.add(current_node + 1)
                # Добавляем соседей только если расстояние позволяет
                if distance < guard_range:
                  for neighbor in get_neighbors(current_node, edges, n):
                    queue.append((neighbor, distance + 1))

    return sorted(list(protected_warehouses))



def get_neighbors(node, edges, n):
    neighbors = []
    for u, v in edges:
        if u == node:
            neighbors.append(v)
        elif v == node:
            neighbors.append(u)
    return neighbors


def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u - 1, v - 1))
    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p - 1, h))


    protected = approximate_solve(n, m, k, edges, guards)
    print(len(protected))
    print(*protected)

solve()

